<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.6"/>
<title>Khepera Library: kb_fifo.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="kteamdoxy.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">Khepera Library
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.6 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="annotated.html"><span>Data&#160;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('kb__fifo_8c_source.html','');});
</script>
<div id="doc-content">
<div class="header">
  <div class="headertitle">
<div class="title">kb_fifo.c</div>  </div>
</div><!--header-->
<div class="contents">
<a href="kb__fifo_8c.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*-------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * Project: KoreBot Library     </span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> * $Author: pbureau $</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * $Date: 2006/10/27 08:53:20 $</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> * $Revision: 1.2 $</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> * ------------------------------------------------------------------------------*/</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;</div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#include &lt;stdio.h&gt;</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#include &lt;stdlib.h&gt;</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="kb__fifo_8h.html">kb_fifo.h</a>&quot;</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="comment">/*--------------------------------------------------------------------*/</span></div>
<div class="line"><a name="l00032"></a><span class="lineno"><a class="line" href="kb__fifo_8h.html#a653ed97d5d6185c333ea6eb08b10a13b">   32</a></span>&#160;<a class="code" href="struct__fifo.html">Fifo</a> <a class="code" href="kb__fifo_8c.html#a653ed97d5d6185c333ea6eb08b10a13b">kb_fifo_fifoEmpty</a>() {</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;   <a class="code" href="struct__fifo.html">Fifo</a> F;</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;   F = (<a class="code" href="kb__fifo_8h.html#afc3d39149b5eb2a6aa005e64baea9d2e">Fifo</a>)malloc(<span class="keyword">sizeof</span>(<span class="keyword">struct</span> <a class="code" href="struct__fifo.html">_fifo</a>));</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;   <span class="keywordflow">if</span> (F == NULL) perror(<span class="stringliteral">&quot;Problem fifo is empty \n\r&quot;</span>);</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;   F-&gt;<a class="code" href="struct__fifo.html#a79fd3045e759daf3cb1c4cce1e98d8d2">length</a> = 0;</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;   F-&gt;<a class="code" href="struct__fifo.html#a1ec3b1ebafcc3add7584f0db65787c8f">mutex</a> = 0;</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;   F-&gt;<a class="code" href="struct__fifo.html#a4a130f4fdfcd918d68279cfa921f8b45">head</a> = F-&gt;<a class="code" href="struct__fifo.html#a54746fa451ff2e093aa27170453212e0">queue</a> = NULL;</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;   <span class="keywordflow">return</span>(F);</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;}</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="comment">/*--------------------------------------------------------------------*/</span></div>
<div class="line"><a name="l00050"></a><span class="lineno"><a class="line" href="kb__fifo_8h.html#af70622515a4a2a566891bc29ac8cf783">   50</a></span>&#160;<span class="keywordtype">int</span> <a class="code" href="kb__fifo_8c.html#af70622515a4a2a566891bc29ac8cf783">kb_fifo_length</a>(<a class="code" href="struct__fifo.html">Fifo</a> F) {</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;   <span class="keywordflow">if</span> (F == NULL) perror(<span class="stringliteral">&quot;Problem fifo length, F is null \n\r&quot;</span>);</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;   <span class="keywordflow">return</span>(F-&gt;<a class="code" href="struct__fifo.html#a79fd3045e759daf3cb1c4cce1e98d8d2">length</a>);</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;}</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;<span class="comment">/*--------------------------------------------------------------------*/</span></div>
<div class="line"><a name="l00062"></a><span class="lineno"><a class="line" href="kb__fifo_8h.html#aced3f6641c3e566418040b86b72484b7">   62</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="kb__fifo_8c.html#ab0860111c9ef37f8aa26d81cf29c4ae6">kb_fifo_enqueue</a>(<a class="code" href="struct__fifo.html">Fifo</a> F, <span class="keywordtype">int</span> elt) {</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;   <a class="code" href="struct__cel.html">kb_cel</a> cel;</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;   <span class="keywordflow">if</span> (F == NULL) perror(<span class="stringliteral">&quot;enqueue problem, F is Null \n\r&quot;</span>);</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;   cel = (<a class="code" href="kb__cel_8h.html#a1368807020d012b6202ef9d038c8651f">kb_cel</a>)malloc(<span class="keyword">sizeof</span>(<span class="keyword">struct</span> <a class="code" href="struct__cel.html">_cel</a>));</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;   <span class="keywordflow">if</span> (cel == NULL) perror(<span class="stringliteral">&quot;enqueue problem, cel is Null&quot;</span>);</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;   cel-&gt;<a class="code" href="struct__cel.html#a0fd3345f3070627989ff576df4659d32">elt</a> = elt;</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;   cel-&gt;<a class="code" href="struct__cel.html#ad48eae66b6cc6dee63c22d676bf0ed3a">next</a> = NULL;</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;   <span class="keywordflow">while</span>((F-&gt;<a class="code" href="struct__fifo.html#a1ec3b1ebafcc3add7584f0db65787c8f">mutex</a>) != 0);</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;   (F-&gt;<a class="code" href="struct__fifo.html#a1ec3b1ebafcc3add7584f0db65787c8f">mutex</a>) = 1;</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;   <span class="keywordflow">if</span> (<a class="code" href="kb__fifo_8c.html#af70622515a4a2a566891bc29ac8cf783">kb_fifo_length</a>(F) == 0)</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;      F-&gt;<a class="code" href="struct__fifo.html#a4a130f4fdfcd918d68279cfa921f8b45">head</a> = F-&gt;<a class="code" href="struct__fifo.html#a54746fa451ff2e093aa27170453212e0">queue</a> = cel;</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;   <span class="keywordflow">else</span> {</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;      F-&gt;<a class="code" href="struct__fifo.html#a54746fa451ff2e093aa27170453212e0">queue</a>-&gt;<a class="code" href="struct__cel.html#ad48eae66b6cc6dee63c22d676bf0ed3a">next</a> = cel;</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;      F-&gt;<a class="code" href="struct__fifo.html#a54746fa451ff2e093aa27170453212e0">queue</a> = cel;</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;   }</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;   ++(F-&gt;length);</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;   (F-&gt;mutex) = 0;</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;}</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;<span class="comment">/*--------------------------------------------------------------------*/</span></div>
<div class="line"><a name="l00089"></a><span class="lineno"><a class="line" href="kb__fifo_8h.html#aea20520a937198a24d0fde1e0c9f12a6">   89</a></span>&#160;<span class="keywordtype">int</span> <a class="code" href="kb__fifo_8c.html#aea20520a937198a24d0fde1e0c9f12a6">kb_fifo_head</a>(<a class="code" href="struct__fifo.html">Fifo</a> F) {</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;   <span class="keywordflow">if</span> (F == NULL || <a class="code" href="kb__fifo_8c.html#af70622515a4a2a566891bc29ac8cf783">kb_fifo_length</a>(F) == 0) perror(<span class="stringliteral">&quot;head problem, F is Null or size = 0 \n\r&quot;</span>);</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;   <span class="keywordflow">return</span>(F-&gt;<a class="code" href="struct__fifo.html#a4a130f4fdfcd918d68279cfa921f8b45">head</a>-&gt;<a class="code" href="struct__cel.html#a0fd3345f3070627989ff576df4659d32">elt</a>);</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;}</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;<span class="comment">/*--------------------------------------------------------------------*/</span></div>
<div class="line"><a name="l00100"></a><span class="lineno"><a class="line" href="kb__fifo_8h.html#a596966aa67631eac86b4d18bd2224459">  100</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="kb__fifo_8c.html#a596966aa67631eac86b4d18bd2224459">kb_fifo_remove</a>(<a class="code" href="struct__fifo.html">Fifo</a> F) {</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;   <a class="code" href="struct__cel.html">kb_cel</a> cel;</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;   <span class="keywordflow">if</span> (F == NULL || <a class="code" href="kb__fifo_8c.html#af70622515a4a2a566891bc29ac8cf783">kb_fifo_length</a>(F) == 0) perror(<span class="stringliteral">&quot;dequeue problem, F is null or size = 0 \n\r&quot;</span>);</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;   </div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;   <span class="keywordflow">while</span>((F-&gt;<a class="code" href="struct__fifo.html#a1ec3b1ebafcc3add7584f0db65787c8f">mutex</a>) != 0);</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;   (F-&gt;<a class="code" href="struct__fifo.html#a1ec3b1ebafcc3add7584f0db65787c8f">mutex</a>) = 1;</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;   cel = F-&gt;<a class="code" href="struct__fifo.html#a4a130f4fdfcd918d68279cfa921f8b45">head</a>;</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;   <span class="keywordflow">if</span> (<a class="code" href="kb__fifo_8c.html#af70622515a4a2a566891bc29ac8cf783">kb_fifo_length</a>(F) == 1)</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;      F-&gt;<a class="code" href="struct__fifo.html#a4a130f4fdfcd918d68279cfa921f8b45">head</a> = F-&gt;<a class="code" href="struct__fifo.html#a54746fa451ff2e093aa27170453212e0">queue</a> = NULL;</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;   <span class="keywordflow">else</span></div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;      F-&gt;<a class="code" href="struct__fifo.html#a4a130f4fdfcd918d68279cfa921f8b45">head</a> = F-&gt;<a class="code" href="struct__fifo.html#a4a130f4fdfcd918d68279cfa921f8b45">head</a>-&gt;<a class="code" href="struct__cel.html#ad48eae66b6cc6dee63c22d676bf0ed3a">next</a>;</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;   --(F-&gt;<a class="code" href="struct__fifo.html#a79fd3045e759daf3cb1c4cce1e98d8d2">length</a>);</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;   (F-&gt;<a class="code" href="struct__fifo.html#a1ec3b1ebafcc3add7584f0db65787c8f">mutex</a>) = 0;</div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;   free(cel);</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;}</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;<span class="comment">/*--------------------------------------------------------------------*/</span></div>
<div class="line"><a name="l00124"></a><span class="lineno"><a class="line" href="kb__fifo_8h.html#aeb87213d01bb1c4ba5b630e2160b575a">  124</a></span>&#160;<span class="keywordtype">int</span> <a class="code" href="kb__fifo_8c.html#aeb87213d01bb1c4ba5b630e2160b575a">kb_fifo_dequeue</a>(<a class="code" href="struct__fifo.html">Fifo</a> F) { </div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;   <a class="code" href="struct__cel.html">kb_cel</a> cel;</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;   <span class="keywordtype">int</span> elt;</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;   <span class="keywordflow">if</span> (F == NULL || <a class="code" href="kb__fifo_8c.html#af70622515a4a2a566891bc29ac8cf783">kb_fifo_length</a>(F) == 0) perror(<span class="stringliteral">&quot;run problem, F is null or size = 0 \n\r&quot;</span>);</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;   </div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;   <span class="keywordflow">while</span>((F-&gt;<a class="code" href="struct__fifo.html#a1ec3b1ebafcc3add7584f0db65787c8f">mutex</a>) != 0);</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;   (F-&gt;<a class="code" href="struct__fifo.html#a1ec3b1ebafcc3add7584f0db65787c8f">mutex</a>) = 1;</div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;   cel = F-&gt;<a class="code" href="struct__fifo.html#a4a130f4fdfcd918d68279cfa921f8b45">head</a>;</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;   elt = cel-&gt;<a class="code" href="struct__cel.html#a0fd3345f3070627989ff576df4659d32">elt</a>;</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;   <span class="keywordflow">if</span> (<a class="code" href="kb__fifo_8c.html#af70622515a4a2a566891bc29ac8cf783">kb_fifo_length</a>(F) == 1)</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;      F-&gt;<a class="code" href="struct__fifo.html#a4a130f4fdfcd918d68279cfa921f8b45">head</a> = F-&gt;<a class="code" href="struct__fifo.html#a54746fa451ff2e093aa27170453212e0">queue</a> = NULL;</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;   <span class="keywordflow">else</span></div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;      F-&gt;<a class="code" href="struct__fifo.html#a4a130f4fdfcd918d68279cfa921f8b45">head</a> = F-&gt;<a class="code" href="struct__fifo.html#a4a130f4fdfcd918d68279cfa921f8b45">head</a>-&gt;<a class="code" href="struct__cel.html#ad48eae66b6cc6dee63c22d676bf0ed3a">next</a>;</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;   free(cel);</div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;   --(F-&gt;<a class="code" href="struct__fifo.html#a79fd3045e759daf3cb1c4cce1e98d8d2">length</a>);</div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;   (F-&gt;<a class="code" href="struct__fifo.html#a1ec3b1ebafcc3add7584f0db65787c8f">mutex</a>) = 0;</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;   <span class="keywordflow">return</span>(elt);</div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;}</div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;</div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;<span class="comment">/*--------------------------------------------------------------------*/</span></div>
<div class="line"><a name="l00151"></a><span class="lineno"><a class="line" href="kb__fifo_8h.html#ac1349e448870144540598cb58dcd72d9">  151</a></span>&#160;<a class="code" href="struct__fifo.html">Fifo</a> <a class="code" href="kb__fifo_8c.html#ac1349e448870144540598cb58dcd72d9">kb_fifo_copy</a>(<a class="code" href="struct__fifo.html">Fifo</a> F) {</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;   <a class="code" href="struct__fifo.html">Fifo</a> G, H;</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;   <a class="code" href="struct__cel.html">kb_cel</a> cel;</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;   <span class="keywordflow">if</span> (F == NULL) perror(<span class="stringliteral">&quot;copy problem, F is null \n\r&quot;</span>);</div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;   H = <a class="code" href="kb__fifo_8c.html#a653ed97d5d6185c333ea6eb08b10a13b">kb_fifo_fifoEmpty</a>();</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;   cel = F-&gt;<a class="code" href="struct__fifo.html#a4a130f4fdfcd918d68279cfa921f8b45">head</a>;</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;   <span class="keywordflow">while</span> (cel != NULL) {</div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;      <a class="code" href="kb__fifo_8c.html#ab0860111c9ef37f8aa26d81cf29c4ae6">kb_fifo_enqueue</a>(H, cel-&gt;<a class="code" href="struct__cel.html#a0fd3345f3070627989ff576df4659d32">elt</a>);</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;      cel = cel-&gt;<a class="code" href="struct__cel.html#ad48eae66b6cc6dee63c22d676bf0ed3a">next</a>;</div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;   }</div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;   G = <a class="code" href="kb__fifo_8c.html#a653ed97d5d6185c333ea6eb08b10a13b">kb_fifo_fifoEmpty</a>();</div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;   cel = H-&gt;<a class="code" href="struct__fifo.html#a4a130f4fdfcd918d68279cfa921f8b45">head</a>;</div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;   <span class="keywordflow">while</span> (cel != NULL) {</div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;      <a class="code" href="kb__fifo_8c.html#ab0860111c9ef37f8aa26d81cf29c4ae6">kb_fifo_enqueue</a>(G, cel-&gt;<a class="code" href="struct__cel.html#a0fd3345f3070627989ff576df4659d32">elt</a>);</div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;      cel = cel-&gt;<a class="code" href="struct__cel.html#ad48eae66b6cc6dee63c22d676bf0ed3a">next</a>;</div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;   }</div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;   <span class="keywordflow">return</span>(G);</div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;}</div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;<span class="comment">/*--------------------------------------------------------------------*/</span></div>
<div class="line"><a name="l00177"></a><span class="lineno"><a class="line" href="kb__fifo_8h.html#a27a5f54405110ea3625142c014c38a7b">  177</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="kb__fifo_8c.html#a27a5f54405110ea3625142c014c38a7b">kb_fifo_printFifo</a>(<a class="code" href="struct__fifo.html">Fifo</a> F) {</div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;   <a class="code" href="struct__cel.html">kb_cel</a> cel;</div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;</div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;   <span class="keywordflow">if</span> (F == NULL) perror(<span class="stringliteral">&quot;print problem, F is null \n\r&quot;</span>);</div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;   cel = F-&gt;<a class="code" href="struct__fifo.html#a4a130f4fdfcd918d68279cfa921f8b45">head</a>;</div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;   <span class="keywordflow">while</span> (cel != NULL) {</div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;     printf(<span class="stringliteral">&quot;%d &quot;</span>, cel-&gt;<a class="code" href="struct__cel.html#a0fd3345f3070627989ff576df4659d32">elt</a>);</div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;     cel = cel-&gt;<a class="code" href="struct__cel.html#ad48eae66b6cc6dee63c22d676bf0ed3a">next</a>;</div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;   }</div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;   printf(<span class="stringliteral">&quot;\n\r&quot;</span>);</div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;}</div>
<div class="ttc" id="struct__cel_html_a0fd3345f3070627989ff576df4659d32"><div class="ttname"><a href="struct__cel.html#a0fd3345f3070627989ff576df4659d32">_cel::elt</a></div><div class="ttdeci">int elt</div><div class="ttdef"><b>Definition:</b> <a href="kb__cel_8h_source.html#l00009">kb_cel.h:9</a></div></div>
<div class="ttc" id="struct__fifo_html_a1ec3b1ebafcc3add7584f0db65787c8f"><div class="ttname"><a href="struct__fifo.html#a1ec3b1ebafcc3add7584f0db65787c8f">_fifo::mutex</a></div><div class="ttdeci">int mutex</div><div class="ttdef"><b>Definition:</b> <a href="kb__fifo_8h_source.html#l00010">kb_fifo.h:10</a></div></div>
<div class="ttc" id="kb__fifo_8c_html_aea20520a937198a24d0fde1e0c9f12a6"><div class="ttname"><a href="kb__fifo_8c.html#aea20520a937198a24d0fde1e0c9f12a6">kb_fifo_head</a></div><div class="ttdeci">int kb_fifo_head(Fifo F)</div><div class="ttdef"><b>Definition:</b> <a href="kb__fifo_8c_source.html#l00089">kb_fifo.c:89</a></div></div>
<div class="ttc" id="struct__fifo_html_a54746fa451ff2e093aa27170453212e0"><div class="ttname"><a href="struct__fifo.html#a54746fa451ff2e093aa27170453212e0">_fifo::queue</a></div><div class="ttdeci">kb_cel queue</div><div class="ttdef"><b>Definition:</b> <a href="kb__fifo_8h_source.html#l00012">kb_fifo.h:12</a></div></div>
<div class="ttc" id="kb__cel_8h_html_a1368807020d012b6202ef9d038c8651f"><div class="ttname"><a href="kb__cel_8h.html#a1368807020d012b6202ef9d038c8651f">kb_cel</a></div><div class="ttdeci">struct _cel * kb_cel</div><div class="ttdef"><b>Definition:</b> <a href="kb__cel_8h_source.html#l00012">kb_cel.h:12</a></div></div>
<div class="ttc" id="struct__cel_html_ad48eae66b6cc6dee63c22d676bf0ed3a"><div class="ttname"><a href="struct__cel.html#ad48eae66b6cc6dee63c22d676bf0ed3a">_cel::next</a></div><div class="ttdeci">struct _cel * next</div><div class="ttdef"><b>Definition:</b> <a href="kb__cel_8h_source.html#l00010">kb_cel.h:10</a></div></div>
<div class="ttc" id="kb__fifo_8c_html_af70622515a4a2a566891bc29ac8cf783"><div class="ttname"><a href="kb__fifo_8c.html#af70622515a4a2a566891bc29ac8cf783">kb_fifo_length</a></div><div class="ttdeci">int kb_fifo_length(Fifo F)</div><div class="ttdef"><b>Definition:</b> <a href="kb__fifo_8c_source.html#l00050">kb_fifo.c:50</a></div></div>
<div class="ttc" id="kb__fifo_8c_html_ab0860111c9ef37f8aa26d81cf29c4ae6"><div class="ttname"><a href="kb__fifo_8c.html#ab0860111c9ef37f8aa26d81cf29c4ae6">kb_fifo_enqueue</a></div><div class="ttdeci">void kb_fifo_enqueue(Fifo F, int elt)</div><div class="ttdef"><b>Definition:</b> <a href="kb__fifo_8c_source.html#l00062">kb_fifo.c:62</a></div></div>
<div class="ttc" id="kb__fifo_8c_html_aeb87213d01bb1c4ba5b630e2160b575a"><div class="ttname"><a href="kb__fifo_8c.html#aeb87213d01bb1c4ba5b630e2160b575a">kb_fifo_dequeue</a></div><div class="ttdeci">int kb_fifo_dequeue(Fifo F)</div><div class="ttdef"><b>Definition:</b> <a href="kb__fifo_8c_source.html#l00124">kb_fifo.c:124</a></div></div>
<div class="ttc" id="kb__fifo_8h_html"><div class="ttname"><a href="kb__fifo_8h.html">kb_fifo.h</a></div></div>
<div class="ttc" id="kb__fifo_8c_html_a27a5f54405110ea3625142c014c38a7b"><div class="ttname"><a href="kb__fifo_8c.html#a27a5f54405110ea3625142c014c38a7b">kb_fifo_printFifo</a></div><div class="ttdeci">void kb_fifo_printFifo(Fifo F)</div><div class="ttdef"><b>Definition:</b> <a href="kb__fifo_8c_source.html#l00177">kb_fifo.c:177</a></div></div>
<div class="ttc" id="kb__fifo_8c_html_a596966aa67631eac86b4d18bd2224459"><div class="ttname"><a href="kb__fifo_8c.html#a596966aa67631eac86b4d18bd2224459">kb_fifo_remove</a></div><div class="ttdeci">void kb_fifo_remove(Fifo F)</div><div class="ttdef"><b>Definition:</b> <a href="kb__fifo_8c_source.html#l00100">kb_fifo.c:100</a></div></div>
<div class="ttc" id="struct__fifo_html"><div class="ttname"><a href="struct__fifo.html">_fifo</a></div><div class="ttdef"><b>Definition:</b> <a href="kb__fifo_8h_source.html#l00009">kb_fifo.h:9</a></div></div>
<div class="ttc" id="struct__cel_html"><div class="ttname"><a href="struct__cel.html">_cel</a></div><div class="ttdef"><b>Definition:</b> <a href="kb__cel_8h_source.html#l00008">kb_cel.h:8</a></div></div>
<div class="ttc" id="kb__fifo_8c_html_ac1349e448870144540598cb58dcd72d9"><div class="ttname"><a href="kb__fifo_8c.html#ac1349e448870144540598cb58dcd72d9">kb_fifo_copy</a></div><div class="ttdeci">Fifo kb_fifo_copy(Fifo F)</div><div class="ttdef"><b>Definition:</b> <a href="kb__fifo_8c_source.html#l00151">kb_fifo.c:151</a></div></div>
<div class="ttc" id="struct__fifo_html_a79fd3045e759daf3cb1c4cce1e98d8d2"><div class="ttname"><a href="struct__fifo.html#a79fd3045e759daf3cb1c4cce1e98d8d2">_fifo::length</a></div><div class="ttdeci">int length</div><div class="ttdef"><b>Definition:</b> <a href="kb__fifo_8h_source.html#l00011">kb_fifo.h:11</a></div></div>
<div class="ttc" id="struct__fifo_html_a4a130f4fdfcd918d68279cfa921f8b45"><div class="ttname"><a href="struct__fifo.html#a4a130f4fdfcd918d68279cfa921f8b45">_fifo::head</a></div><div class="ttdeci">kb_cel head</div><div class="ttdef"><b>Definition:</b> <a href="kb__fifo_8h_source.html#l00012">kb_fifo.h:12</a></div></div>
<div class="ttc" id="kb__fifo_8h_html_afc3d39149b5eb2a6aa005e64baea9d2e"><div class="ttname"><a href="kb__fifo_8h.html#afc3d39149b5eb2a6aa005e64baea9d2e">Fifo</a></div><div class="ttdeci">struct _fifo * Fifo</div><div class="ttdef"><b>Definition:</b> <a href="kb__fifo_8h_source.html#l00015">kb_fifo.h:15</a></div></div>
<div class="ttc" id="kb__fifo_8c_html_a653ed97d5d6185c333ea6eb08b10a13b"><div class="ttname"><a href="kb__fifo_8c.html#a653ed97d5d6185c333ea6eb08b10a13b">kb_fifo_fifoEmpty</a></div><div class="ttdeci">Fifo kb_fifo_fifoEmpty()</div><div class="ttdef"><b>Definition:</b> <a href="kb__fifo_8c_source.html#l00032">kb_fifo.c:32</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="kb__fifo_8c.html">kb_fifo.c</a></li>
    <li class="footer">Generated on Wed Jul 6 2016 19:39:17 for Khepera Library by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.6 </li>
  </ul>
</div>
</body>
</html>
